
                      ANNOUNCING NSS_LDAP 0.2
                      =======================

       ********************** WARNING ***************************
       * THIS IS ALPHA SOFTWARE, FOR DEVELOPERS ONLY. IT MAY    *
       * BLOW UP. PLEASE DO NOT REDISTRIBUTE IT.                *
       * PLEASE CONTACT THE AUTHOR SO YOU CAN BE ADDED TO A     *
       * MAILING LIST OF DEVELOPERS.                            *
       * PLEASE SEND ANY PATCHES TO nss_ldap@roach.xedoc.com.au *
       **********************************************************

1. What is nss_ldap?
--------------------

nss_ldap is a set of C library extensions which allows X.500 and LDAP
directory servers to be used as a primary source of aliases, ethers,
groups, hosts, networks, protocol, users, RPCs, services and shadow
passwords (instead of or in addition to using flat files or NIS).

nss_ldap nominally supports the following operating system libraries:

	o the Nameservice Switch in Solaris 2.4-2.6
	o the Nameservice Switch in the GNU C Library 2.0 (as
          in libc.so.6 under Linux)
	o the Information Retrieval Service (IRS) in BIND 
	o preliminary support for generic SVR4 Unix, eg. IRIX

nss_ldap is an implementation of the schema specified in RFC 2307
and is compatible with that used in Xedoc Software Development Inc.'s
LDAP/NIS gateway (ypldapd) and Rhapsody.

2. What can it do for me?
-------------------------

nss_ldap lets you use LDAP servers, like Netscape's Directory Server,
to distribute users, hosts, groups and other like information throughout
an organization. Because LDAP is a hierarchical directory service,
you can distribute the information in a manner which reflects an
organizational structure. This contrasts with the flat, single domain
policy of NIS. LDAP has many of the advantages of NIS+ (security and
scalability) without the complexity.

nss_ldap will work alongside your existing NIS, NIS+, DNS and flat file
name services. More importantly, because it builds as a shared library,
you don't have to recompile any of your applications to take advantage
of LDAP. When used with a directory server under NT, it may be helpful
in synchronizing Unix and NT accounts.

3. What are its limitations?
----------------------------

Currently, some "maps" (like bootparams) are not supported. It's also
alpha software, so use it at your own risk. This should be considered
with respect to the fact the nss_ldap is loaded into the address space
of *every* process which uses the C library's resolver functions and
has LDAP in its search order. (This isn't entirely true under Solaris,
but the implications are similar.)

Finally, it only supports Linux and Solaris (and some versions of
BSD). You might want to look at ypldapd (see below) if you need to
support NIS clients.

4. How much does it cost?
-------------------------

It's free, and distributed under the GNU General Library Public
Licence (GLPL). Please read the file COPYING.LIB For more information.

5. Where do I get it?
---------------------

nss_ldap is available from the author directly at the moment, but
eventually:

	<URL:http://www.xedoc.com.au/~lukeh/ldap/nss_ldap.tar.gz>

We have also made available some Perl scripts for populating LDAP
databases from existing flat files, NIS and/or NetInfo data.

	<URL:http://www.xedoc.com.au/~lukeh/ldap/MigrationTools.tar.gz>

You'll need to compile a position-independent LDAP client library
(libldap). You can either get the entire LDAP package from the University
of Michigan (see below) and add "-fPIC" (if you're using gcc) to the
C compiler flags, or download binaries for Solaris SPARC 2.6 from:

	<URL:http://www.xedoc.com.au/~lukeh/ldap/libldap.so.gz>

It's easy to build a single, shared, library (libldap.so) from liblber
and libldap. Contact the author for the makefiles.

These days, you're better off using the Mozilla LDAP SDK (downloadable
from http://www.mozilla.org) -- it's heaps better than the UMich SDK.

6. Where can I get more information?
------------------------------------

To discuss nss_ldap, ypldapd, and related technologies, you may subscribe
to the following mailing list:

	<URL:mailto:ldap-nis-interest-request@ufo.com.au>

Send an electronic mail message with "subscribe" in the message body to
join the list.

To contact the developers, email:

	<URL:mailto:nss_ldap@roach.xedoc.com.au>

For more information on using LDAP for name resolution, and related software,
see:

	<URL:http://www.xedoc.com.au/~lukeh/ldap/>

And if you need an LDAP server, or some general information on LDAP,
see:

	<URL:http://www.critical-angle.com/ldapworld>

7. Who wrote it?
----------------

nss_ldap was written by Luke Howard <lukeh@xedoc.com>.

